<template>
  <div class="settings-container mt10">
    <ControlGroup
      v-model="tab"
      :items="groupItems"
      theme="light"
    />
    <component
      :is="currentComponent"
      :settings="currentSubSettings"
      @on-save-field="onSaveField"
    />
  </div>
</template>

<script>
import ControlGroup from 'common-components/src/obComponents/obControlGroup'
import CommonSettings from './commonSettings'
import AuctionSettings from './auctionSettings'
import BookingSettings from './bookingSettings'
import CircleTripSettings from './circleTripSettings'
import ResourcesSettings from './resourcesSettings'
import { mapActions, mapGetters } from 'vuex'

const tabs = [
  {
    label: 'Общие настройки автопоиска',
    value: 'commonSettings',
    component: CommonSettings
  },
  {
    label: 'Букинги',
    value: 'bookingSettings',
    component: BookingSettings
  },
  {
    label: 'Аукционы',
    value: 'auctionSettings',
    component: AuctionSettings,
  },
  // {
  //   label: 'Настрокйи Fit-функции',
  //   value: 'FOR_CLIENT'
  // },
  {
    label: 'Кругорейсы',
    value: 'circleTripSettings',
    component: CircleTripSettings
  },
  {
    label: 'Работа с ресурсами',
    value: 'resourcesSettings',
    component: ResourcesSettings
  },
]

export default {
  name: 'ClicarSettingsAutosearch',
  components: {
    ControlGroup
  },
  data () {
    return {
      tab: 'commonSettings'
    }
  },
  mounted () {
    this.getAutosearchSettings()
  },
  methods: {
    ...mapActions({
      getAutosearchSettings: 'clicarSettings_3/getAutosearchSettings',
      setSettingValue: 'clicarSettings_3/setSettingValue',
    }),
    onSaveField ({ path, value }) {
      value = typeof value === 'string' ? value.replace(',', '.') : value

      this.setSettingValue({ path: `${this.currentTab.value}.${path}`, value })
    }
  },
  computed: {
    ...mapGetters({
      currentSettings: 'clicarSettings_3/currentSettings'
    }),
    groupItems () {
      return tabs
    },
    currentTab () {
      return this.groupItems.find(item => item.value === this.tab)
    },
    currentComponent () {
      return this.currentTab?.component || null
    },
    currentSubSettings () {
      return this.currentSettings[this.currentTab?.value] || {}
    }
  },
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";
.mt10 {
  margin-top: 10px;
}

.title {
  margin-bottom: 10px;
  @include font-mixin(20px,28px, 700, $color-text-base, 0.4px);
}

</style>